"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollOffset = exports.BaseLinePositionType = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
var BaseLinePositionType;
(function (BaseLinePositionType) {
    BaseLinePositionType[BaseLinePositionType["TOP"] = 0] = "TOP";
    BaseLinePositionType[BaseLinePositionType["MIDDLE"] = 1] = "MIDDLE";
    BaseLinePositionType[BaseLinePositionType["BOTTOM"] = 2] = "BOTTOM";
})(BaseLinePositionType = exports.BaseLinePositionType || (exports.BaseLinePositionType = {}));
function ScrollOffset(prop) {
    var _a, _b, _c;
    const [active, setActive] = (0, react_1.useState)(false);
    const targetID = prop.targetID;
    const baseLineOption = Object.assign({ position: BaseLinePositionType.TOP, offset: 0 }, prop.baseLineOption);
    const elementOption = Object.assign({ topOffset: 0, bottomOffset: 0 }, prop.elementOption);
    const execOnStart = (_a = prop.execOnStart) !== null && _a !== void 0 ? _a : true;
    const activeClassName = (_b = prop.activeClassName) !== null && _b !== void 0 ? _b : "";
    const className = (_c = prop.className) !== null && _c !== void 0 ? _c : "";
    const onScrollEvent = () => {
        var _a;
        const elementRect = (_a = document
            .querySelector("#" + targetID)) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect();
        if (elementRect == null)
            return;
        const topScroll = elementRect.top + window.scrollY + elementOption.topOffset;
        const bottomScroll = elementRect.bottom + window.scrollY + elementOption.bottomOffset;
        const baseLinePos = window.scrollY +
            (baseLineOption.position == BaseLinePositionType.TOP
                ? 0
                : baseLineOption.position == BaseLinePositionType.MIDDLE
                    ? window.innerHeight / 2
                    : window.innerHeight) +
            baseLineOption.offset;
        setActive(topScroll <= baseLinePos && baseLinePos <= bottomScroll);
    };
    const onClickEvent = () => {
        var _a;
        const elementRect = (_a = document
            .querySelector("#" + targetID)) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect();
        if (elementRect == null)
            return;
        window.scrollTo({
            top: elementRect.top + window.scrollY - baseLineOption.offset,
            behavior: "smooth",
        });
    };
    (0, react_1.useEffect)(() => {
        window.addEventListener("scroll", onScrollEvent);
        if (execOnStart)
            onScrollEvent();
        return () => {
            window.removeEventListener("scroll", onScrollEvent);
        };
    });
    return ((0, jsx_runtime_1.jsx)("div", Object.assign({ className: className + " " + (active ? activeClassName : ""), onClick: onClickEvent }, { children: prop.children }), void 0));
}
exports.ScrollOffset = ScrollOffset;
